
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef VELODYNE_SCAN_H
#define VELODYNE_SCAN_H


/* Structures definies par d'autres modules */

#include "server/tclservClient/genPosTclservClientDecode.h"

#include "server/tclservClient/pomTclservClientDecode.h"


/* Structures du module */
#include "server/velodynePosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
int scan_buf_struct_VELODYNE_TARGETTRACKING_POSTER_STR (char** buf, struct VELODYNE_TARGETTRACKING_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR (char** buf, struct VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR (char** buf, struct VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_VELODYNE_THREEDIMAGE_POSTER_STR (char** buf, struct VELODYNE_THREEDIMAGE_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_VELODYNE_STR (char** buf, struct VELODYNE_STR *x, int nDim, int *dims );
int scan_buf_struct_velodyneOneShotParams (char** buf, struct velodyneOneShotParams *x, int nDim, int *dims );
int scan_buf_struct_velodyneSaveParams (char** buf, struct velodyneSaveParams *x, int nDim, int *dims );
int scan_buf_struct_velodyneTargetTrackingFileOutputParams (char** buf, struct velodyneTargetTrackingFileOutputParams *x, int nDim, int *dims );
int scan_buf_struct_velodyneTargetTrackingParams (char** buf, struct velodyneTargetTrackingParams *x, int nDim, int *dims );
int scan_buf_struct_velodyneTargetDetectionFileOutput (char** buf, struct velodyneTargetDetectionFileOutput *x, int nDim, int *dims );
int scan_buf_struct_velodyneTargetDetectionParams (char** buf, struct velodyneTargetDetectionParams *x, int nDim, int *dims );
int scan_buf_struct_velodyneTargetParams (char** buf, struct velodyneTargetParams *x, int nDim, int *dims );
int scan_buf_enum_velodyneVerbosity (char** buf, enum velodyneVerbosity *x, int nDim, int *dims );
int scan_buf_struct_velodyneFOVRemoveLineParams (char** buf, struct velodyneFOVRemoveLineParams *x, int nDim, int *dims );
int scan_buf_struct_velodyneFOVRemoveHeadingSectorParams (char** buf, struct velodyneFOVRemoveHeadingSectorParams *x, int nDim, int *dims );
int scan_buf_struct_velodyneInitParams (char** buf, struct velodyneInitParams *x, int nDim, int *dims );
int scan_buf_enum_velodyneModel (char** buf, enum velodyneModel *x, int nDim, int *dims );
int scan_buf_enum_velodyneMode (char** buf, enum velodyneMode *x, int nDim, int *dims );
int scan_buf_enum_velodyneBoolean (char** buf, enum velodyneBoolean *x, int nDim, int *dims );
int scan_buf_struct_velodyne3DImage (char** buf, struct velodyne3DImage *x, int nDim, int *dims );
int scan_buf_struct_velodyne3DPoint (char** buf, struct velodyne3DPoint *x, int nDim, int *dims );
int scan_buf_enum_velodyne3DPointStatus (char** buf, enum velodyne3DPointStatus *x, int nDim, int *dims );

/* ======================== SCAN DES TYPEDEF ============================= */

int scan_buf_velodyne3DPointStatus (char** buf, velodyne3DPointStatus *x, int nDim, int *dims );
int scan_buf_velodyne3DPoint (char** buf, velodyne3DPoint *x, int nDim, int *dims );
int scan_buf_velodyne3DImage (char** buf, velodyne3DImage *x, int nDim, int *dims );
int scan_buf_velodyneBoolean (char** buf, velodyneBoolean *x, int nDim, int *dims );
int scan_buf_velodyneMode (char** buf, velodyneMode *x, int nDim, int *dims );
int scan_buf_velodyneModel (char** buf, velodyneModel *x, int nDim, int *dims );
int scan_buf_velodyneInitParams (char** buf, velodyneInitParams *x, int nDim, int *dims );
int scan_buf_velodyneFOVRemoveHeadingSectorParams (char** buf, velodyneFOVRemoveHeadingSectorParams *x, int nDim, int *dims );
int scan_buf_velodyneFOVRemoveLineParams (char** buf, velodyneFOVRemoveLineParams *x, int nDim, int *dims );
int scan_buf_velodyneVerbosity (char** buf, velodyneVerbosity *x, int nDim, int *dims );
int scan_buf_velodyneTargetParams (char** buf, velodyneTargetParams *x, int nDim, int *dims );
int scan_buf_velodyneTargetDetectionParams (char** buf, velodyneTargetDetectionParams *x, int nDim, int *dims );
int scan_buf_velodyneTargetDetectionFileOutput (char** buf, velodyneTargetDetectionFileOutput *x, int nDim, int *dims );
int scan_buf_velodyneTargetTrackingParams (char** buf, velodyneTargetTrackingParams *x, int nDim, int *dims );
int scan_buf_velodyneTargetTrackingFileOutputParams (char** buf, velodyneTargetTrackingFileOutputParams *x, int nDim, int *dims );
int scan_buf_velodyneSaveParams (char** buf, velodyneSaveParams *x, int nDim, int *dims );
int scan_buf_velodyneOneShotParams (char** buf, velodyneOneShotParams *x, int nDim, int *dims );
int scan_buf_VELODYNE_STR (char** buf, VELODYNE_STR *x, int nDim, int *dims );
int scan_buf_VELODYNE_THREEDIMAGE_POSTER_STR (char** buf, VELODYNE_THREEDIMAGE_POSTER_STR *x, int nDim, int *dims );
int scan_buf_VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR (char** buf, VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR *x, int nDim, int *dims );
int scan_buf_VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR (char** buf, VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR *x, int nDim, int *dims );
int scan_buf_VELODYNE_TARGETTRACKING_POSTER_STR (char** buf, VELODYNE_TARGETTRACKING_POSTER_STR *x, int nDim, int *dims );
#ifdef __cplusplus
}
#endif

#endif /* VELODYNE_SCAN_H */

