
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef velodyne_TCLSERV_CLIENT_MSG_LIB_H
#define velodyne_TCLSERV_CLIENT_MSG_LIB_H

#include <server/velodyneType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int velodyneTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int velodyneTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int velodyneTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 velodyneInitParams *(in_initParams) 
		);

int velodyneTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				velodyneInitParams *(in_initParams) ,
				
				int *bilan);

int velodyneTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					velodyneInitParams *(in_initParams) ,
					
					int *bilan);




int velodyneTclservClientGetInitParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientGetInitParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       velodyneInitParams *(out_initParams),
			       int *bilan);

int velodyneTclservClientGetInitParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 velodyneInitParams *(out_initParams),
				 int *bilan);




int velodyneTclservClientSetReadModeParamsRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 velodyneSaveParams *(in_readModeParams) 
		);

int velodyneTclservClientSetReadModeParamsReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientSetReadModeParamsRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				velodyneSaveParams *(in_readModeParams) ,
				
				int *bilan);

int velodyneTclservClientSetReadModeParamsRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					velodyneSaveParams *(in_readModeParams) ,
					
					int *bilan);




int velodyneTclservClientGetReadModeParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientGetReadModeParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       velodyneSaveParams *(out_readModeParams),
			       int *bilan);

int velodyneTclservClientGetReadModeParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 velodyneSaveParams *(out_readModeParams),
				 int *bilan);




int velodyneTclservClientSetSensorToMainPlaybackRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 POM_EULER *(in_sensorToMain)
		);

int velodyneTclservClientSetSensorToMainPlaybackReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int velodyneTclservClientSetSensorToMainPlaybackRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 POM_EULER *(in_sensorToMain) ,
				 
				 int *bilan);




int velodyneTclservClientFOVRemoveHeadingSectorRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 velodyneFOVRemoveHeadingSectorParams *(in_fovRemoveHeadingSectorParams) 
		);

int velodyneTclservClientFOVRemoveHeadingSectorReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientFOVRemoveHeadingSectorRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				velodyneFOVRemoveHeadingSectorParams *(in_fovRemoveHeadingSectorParams) ,
				
				int *bilan);

int velodyneTclservClientFOVRemoveHeadingSectorRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					velodyneFOVRemoveHeadingSectorParams *(in_fovRemoveHeadingSectorParams) ,
					
					int *bilan);




int velodyneTclservClientFOVRemoveLineRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 velodyneFOVRemoveLineParams *(in_fovRemoveLineParams) 
		);

int velodyneTclservClientFOVRemoveLineReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientFOVRemoveLineRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				velodyneFOVRemoveLineParams *(in_fovRemoveLineParams) ,
				
				int *bilan);

int velodyneTclservClientFOVRemoveLineRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					velodyneFOVRemoveLineParams *(in_fovRemoveLineParams) ,
					
					int *bilan);




int velodyneTclservClientStartAcquisitionRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int velodyneTclservClientStartAcquisitionReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientStartAcquisitionRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int velodyneTclservClientStartAcquisitionRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int velodyneTclservClientStopAcquisitionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientStopAcquisitionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int velodyneTclservClientStopAcquisitionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int velodyneTclservClientOneShotRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 velodyneOneShotParams *(in_oneShotParams) 
		);

int velodyneTclservClientOneShotReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientOneShotRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				velodyneOneShotParams *(in_oneShotParams) ,
				
				int *bilan);

int velodyneTclservClientOneShotRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					velodyneOneShotParams *(in_oneShotParams) ,
					
					int *bilan);




int velodyneTclservClientSetTargetDetectionParamsRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 velodyneTargetDetectionParams *(in_targetDetectionParams) 
		);

int velodyneTclservClientSetTargetDetectionParamsReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientSetTargetDetectionParamsRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				velodyneTargetDetectionParams *(in_targetDetectionParams) ,
				
				int *bilan);

int velodyneTclservClientSetTargetDetectionParamsRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					velodyneTargetDetectionParams *(in_targetDetectionParams) ,
					
					int *bilan);




int velodyneTclservClientGetTargetDetectionParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientGetTargetDetectionParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       velodyneTargetDetectionParams *(out_targetDetectionParams),
			       int *bilan);

int velodyneTclservClientGetTargetDetectionParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 velodyneTargetDetectionParams *(out_targetDetectionParams),
				 int *bilan);




int velodyneTclservClientSetTargetDetectionFileOutputRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 velodyneTargetDetectionFileOutput *(in_targetDetectionFileOutput)
		);

int velodyneTclservClientSetTargetDetectionFileOutputReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int velodyneTclservClientSetTargetDetectionFileOutputRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 velodyneTargetDetectionFileOutput *(in_targetDetectionFileOutput) ,
				 
				 int *bilan);




int velodyneTclservClientGetTargetDetectionFileOutputRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientGetTargetDetectionFileOutputReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       velodyneTargetDetectionFileOutput *(out_targetDetectionFileOutput),
			       int *bilan);

int velodyneTclservClientGetTargetDetectionFileOutputRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 velodyneTargetDetectionFileOutput *(out_targetDetectionFileOutput),
				 int *bilan);




int velodyneTclservClientSetTargetParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 velodyneTargetParams *(in_targetParams)
		);

int velodyneTclservClientSetTargetParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int velodyneTclservClientSetTargetParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 velodyneTargetParams *(in_targetParams) ,
				 
				 int *bilan);




int velodyneTclservClientGetTargetParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientGetTargetParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       velodyneTargetParams *(out_targetParams),
			       int *bilan);

int velodyneTclservClientGetTargetParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 velodyneTargetParams *(out_targetParams),
				 int *bilan);




int velodyneTclservClientStopTargetDetectionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientStopTargetDetectionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int velodyneTclservClientStopTargetDetectionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int velodyneTclservClientDumpTargetRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 velodyneSaveParams *(in_saveParams) 
		);

int velodyneTclservClientDumpTargetReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientDumpTargetRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				velodyneSaveParams *(in_saveParams) ,
				
				int *bilan);

int velodyneTclservClientDumpTargetRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					velodyneSaveParams *(in_saveParams) ,
					
					int *bilan);




int velodyneTclservClientSetTargetTrackingParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 velodyneTargetTrackingParams *(in_targetTrackingParams)
		);

int velodyneTclservClientSetTargetTrackingParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int velodyneTclservClientSetTargetTrackingParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 velodyneTargetTrackingParams *(in_targetTrackingParams) ,
				 
				 int *bilan);




int velodyneTclservClientGetTargetTrackingParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientGetTargetTrackingParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       velodyneTargetTrackingParams *(out_targetTrackingParams),
			       int *bilan);

int velodyneTclservClientGetTargetTrackingParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 velodyneTargetTrackingParams *(out_targetTrackingParams),
				 int *bilan);




int velodyneTclservClientSetTargetTrackingFileOutputParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 velodyneTargetTrackingFileOutputParams *(in_targetTrackingFileOutputParams)
		);

int velodyneTclservClientSetTargetTrackingFileOutputParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int velodyneTclservClientSetTargetTrackingFileOutputParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 velodyneTargetTrackingFileOutputParams *(in_targetTrackingFileOutputParams) ,
				 
				 int *bilan);




int velodyneTclservClientGetTargetTrackingFileOutputParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientGetTargetTrackingFileOutputParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       velodyneTargetTrackingFileOutputParams *(out_targetTrackingFileOutputParams),
			       int *bilan);

int velodyneTclservClientGetTargetTrackingFileOutputParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 velodyneTargetTrackingFileOutputParams *(out_targetTrackingFileOutputParams),
				 int *bilan);




int velodyneTclservClientSetSaveParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 velodyneSaveParams *(in_saveParams)
		);

int velodyneTclservClientSetSaveParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int velodyneTclservClientSetSaveParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 velodyneSaveParams *(in_saveParams) ,
				 
				 int *bilan);




int velodyneTclservClientGetSaveParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientGetSaveParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       velodyneSaveParams *(out_saveParams),
			       int *bilan);

int velodyneTclservClientGetSaveParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 velodyneSaveParams *(out_saveParams),
				 int *bilan);




int velodyneTclservClientSetSaveIm3DParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 velodyneSaveParams *(in_saveIm3DParams)
		);

int velodyneTclservClientSetSaveIm3DParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int velodyneTclservClientSetSaveIm3DParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 velodyneSaveParams *(in_saveIm3DParams) ,
				 
				 int *bilan);




int velodyneTclservClientGetSaveIm3DParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int velodyneTclservClientGetSaveIm3DParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       velodyneSaveParams *(out_saveIm3DParams),
			       int *bilan);

int velodyneTclservClientGetSaveIm3DParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 velodyneSaveParams *(out_saveIm3DParams),
				 int *bilan);




int velodyneTclservClientSaveRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int velodyneTclservClientSaveReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientSaveRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int velodyneTclservClientSaveRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int velodyneTclservClientSaveIm3DRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int velodyneTclservClientSaveIm3DReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int velodyneTclservClientSaveIm3DRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int velodyneTclservClientSaveIm3DRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* velodyneTCLSERV_CLIENT_MSG_LIB_H */

