
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] velodyneInstall] >= 0 } {
    interp expose {} velodyneInstall
}

proc ::velodyneInstall { name } {
    foreach rqst { "Init" "GetInitParams" "SetReadModeParams" "GetReadModeParams" "SetSensorToMainPlayback" "FOVRemoveHeadingSector" "FOVRemoveLine" "StartAcquisition" "StopAcquisition" "OneShot" "SetTargetDetectionParams" "GetTargetDetectionParams" "SetTargetDetectionFileOutput" "GetTargetDetectionFileOutput" "SetTargetParams" "GetTargetParams" "StopTargetDetection" "DumpTarget" "SetTargetTrackingParams" "GetTargetTrackingParams" "SetTargetTrackingFileOutputParams" "GetTargetTrackingFileOutputParams" "SetSaveParams" "GetSaveParams" "SetSaveIm3DParams" "GetSaveIm3DParams" "Save" "SaveIm3D" "ThreeDImagevelodyne3DImagePosterRead" "TargetAbsolutePositionGENPOS_TRAJ_POINTSPosterRead" "TargetRelativePositionGENPOS_TRAJ_POINTSPosterRead" "TargetTrackingGENPOS_TRAJ_POINTSPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} velodyne$rqst $name
    }
}

interp hide {} velodyneInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneInit] >= 0 } {
    interp expose {} velodyneInit
}
if { [lsearch [interp hidden] velodyneInitFormatOutput] >= 0 } {
    interp expose {} velodyneInitFormatOutput
}

proc ::velodyneInit { name args } {
    set format {}
    lappend format [list { "VELODYNE_READ" "VELODYNE_FROM_FILE" "VELODYNE_LIVE" } "Connect to the sensor or a file ?" "VELODYNE_LIVE" ]
    lappend format [list { "VELODYNE_HDL64" "VELODYNE_HDL32" "VELODYNE_VLP16" } "Which model?" "VELODYNE_HDL32" ]
    lappend format [list string "tcpdump file to read" "/tmp/velodyne.pcap" ]
    lappend format [list { "VELODYNE_TRUE" "VELODYNE_FALSE" } "Enable 3D image organization?" "VELODYNE_FALSE" ]
    lappend format [list { "VELODYNE_TRUE" "VELODYNE_FALSE" } "Use pom ?" "VELODYNE_FALSE" ]
    lappend format [list string "Pom sensor position poster name" "pomVelodyneFramePos" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Opens the interface and connects to the position input." \
	"velodyneInitParams\n| velodyneMode mode\n| velodyneModel model\n| char inputFileName\[128\]\n| velodyneBoolean enableOrganization\n| velodyneBoolean usePom\n| char sensorPosPoster\[128\]\n" \
	6 \
	$format \
	$args ]
}


proc ::velodyneInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneInit
interp hide {} velodyneInitFormatOutput





# GetInitParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneGetInitParams] >= 0 } {
    interp expose {} velodyneGetInitParams
}
if { [lsearch [interp hidden] velodyneGetInitParamsFormatOutput] >= 0 } {
    interp expose {} velodyneGetInitParamsFormatOutput
}

proc ::velodyneGetInitParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetInitParams" \
	"Prints the init params" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneGetInitParamsFormatOutput { list } {
    set format { {} status { } { initParams { } mode { } model { } inputFileName { } enableOrganization { } usePom { } sensorPosPoster } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneGetInitParams
interp hide {} velodyneGetInitParamsFormatOutput





# SetReadModeParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSetReadModeParams] >= 0 } {
    interp expose {} velodyneSetReadModeParams
}
if { [lsearch [interp hidden] velodyneSetReadModeParamsFormatOutput] >= 0 } {
    interp expose {} velodyneSetReadModeParamsFormatOutput
}

proc ::velodyneSetReadModeParams { name args } {
    set format {}
    lappend format [list string "File name" "/tmp/velodyneShot" ]
    lappend format [list int "Number of the extension" 0 ]

    return [ ::cs::rqstSend "${name}" "SetReadModeParams" \
	"Sets the read mode parameters" \
	"velodyneSaveParams\n| char baseName\[128\]\n| int num\n" \
	2 \
	$format \
	$args ]
}


proc ::velodyneSetReadModeParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSetReadModeParams
interp hide {} velodyneSetReadModeParamsFormatOutput





# GetReadModeParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneGetReadModeParams] >= 0 } {
    interp expose {} velodyneGetReadModeParams
}
if { [lsearch [interp hidden] velodyneGetReadModeParamsFormatOutput] >= 0 } {
    interp expose {} velodyneGetReadModeParamsFormatOutput
}

proc ::velodyneGetReadModeParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetReadModeParams" \
	"Prints the read mode parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneGetReadModeParamsFormatOutput { list } {
    set format { {} status { } { readModeParams { } baseName { } num } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneGetReadModeParams
interp hide {} velodyneGetReadModeParamsFormatOutput





# SetSensorToMainPlayback ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSetSensorToMainPlayback] >= 0 } {
    interp expose {} velodyneSetSensorToMainPlayback
}
if { [lsearch [interp hidden] velodyneSetSensorToMainPlaybackFormatOutput] >= 0 } {
    interp expose {} velodyneSetSensorToMainPlaybackFormatOutput
}

proc ::velodyneSetSensorToMainPlayback { name args } {
    set format {}
    lappend format [list double "Yaw angle (rad), 0 <= yaw < 2pi" 0.000000 ]
    lappend format [list double "Pitch angle (rad), 0 <= pitch < 2pi" 0.000000 ]
    lappend format [list double "Roll angle (rad), 0 <= roll < 2pi" 0.000000 ]
    lappend format [list double "x coordinate" 0.000000 ]
    lappend format [list double "y coordinate" 0.000000 ]
    lappend format [list double "z coordinate" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "SetSensorToMainPlayback" \
	"Sets the sensor-to-main transformation in playback mode" \
	"POM_EULER\n| double yaw\n| double pitch\n| double roll\n| double x\n| double y\n| double z\n" \
	6 \
	$format \
	$args ]
}


proc ::velodyneSetSensorToMainPlaybackFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSetSensorToMainPlayback
interp hide {} velodyneSetSensorToMainPlaybackFormatOutput





# FOVRemoveHeadingSector ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneFOVRemoveHeadingSector] >= 0 } {
    interp expose {} velodyneFOVRemoveHeadingSector
}
if { [lsearch [interp hidden] velodyneFOVRemoveHeadingSectorFormatOutput] >= 0 } {
    interp expose {} velodyneFOVRemoveHeadingSectorFormatOutput
}

proc ::velodyneFOVRemoveHeadingSector { name args } {
    set format {}
    lappend format [list double "First sector angle (deg), in the robot's frame" 0.000000 ]
    lappend format [list double "Last sector angle (deg), in the robot's frame" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "FOVRemoveHeadingSector" \
	"Selects a heading sector to be removed from the FOV" \
	"velodyneFOVRemoveHeadingSectorParams\n| double firstSectorAngle\n| double lastSectorAngle\n" \
	2 \
	$format \
	$args ]
}


proc ::velodyneFOVRemoveHeadingSectorFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneFOVRemoveHeadingSector
interp hide {} velodyneFOVRemoveHeadingSectorFormatOutput





# FOVRemoveLine ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneFOVRemoveLine] >= 0 } {
    interp expose {} velodyneFOVRemoveLine
}
if { [lsearch [interp hidden] velodyneFOVRemoveLineFormatOutput] >= 0 } {
    interp expose {} velodyneFOVRemoveLineFormatOutput
}

proc ::velodyneFOVRemoveLine { name args } {
    set format {}
    lappend format [list int "Line" 0 ]

    return [ ::cs::rqstSend "${name}" "FOVRemoveLine" \
	"Selects a line to be removed from the FOV" \
	"velodyneFOVRemoveLineParams\n| int line\n" \
	1 \
	$format \
	$args ]
}


proc ::velodyneFOVRemoveLineFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneFOVRemoveLine
interp hide {} velodyneFOVRemoveLineFormatOutput





# StartAcquisition ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneStartAcquisition] >= 0 } {
    interp expose {} velodyneStartAcquisition
}
if { [lsearch [interp hidden] velodyneStartAcquisitionFormatOutput] >= 0 } {
    interp expose {} velodyneStartAcquisitionFormatOutput
}

proc ::velodyneStartAcquisition { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StartAcquisition" \
	"Starts the data acquisition" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneStartAcquisitionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneStartAcquisition
interp hide {} velodyneStartAcquisitionFormatOutput





# StopAcquisition ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneStopAcquisition] >= 0 } {
    interp expose {} velodyneStopAcquisition
}
if { [lsearch [interp hidden] velodyneStopAcquisitionFormatOutput] >= 0 } {
    interp expose {} velodyneStopAcquisitionFormatOutput
}

proc ::velodyneStopAcquisition { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopAcquisition" \
	"Stops the data acquisition" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneStopAcquisitionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneStopAcquisition
interp hide {} velodyneStopAcquisitionFormatOutput





# OneShot ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneOneShot] >= 0 } {
    interp expose {} velodyneOneShot
}
if { [lsearch [interp hidden] velodyneOneShotFormatOutput] >= 0 } {
    interp expose {} velodyneOneShotFormatOutput
}

proc ::velodyneOneShot { name args } {
    set format {}
    lappend format [list double "First angle of the scan (in degrees)" -180.000000 ]
    lappend format [list double "Last angle of the scan (in degrees)" 180.000000 ]

    return [ ::cs::rqstSend "${name}" "OneShot" \
	"Acquire some scans from the velodyne sensor" \
	"velodyneOneShotParams\n| double firstAngle\n| double lastAngle\n" \
	2 \
	$format \
	$args ]
}


proc ::velodyneOneShotFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneOneShot
interp hide {} velodyneOneShotFormatOutput





# SetTargetDetectionParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSetTargetDetectionParams] >= 0 } {
    interp expose {} velodyneSetTargetDetectionParams
}
if { [lsearch [interp hidden] velodyneSetTargetDetectionParamsFormatOutput] >= 0 } {
    interp expose {} velodyneSetTargetDetectionParamsFormatOutput
}

proc ::velodyneSetTargetDetectionParams { name args } {
    set format {}
    lappend format [list { "VELODYNE_TRUE" "VELODYNE_FALSE" } "Detect targets?" "VELODYNE_FALSE" ]
    lappend format [list { "VELODYNE_TRUE" "VELODYNE_FALSE" } "Continuous tracking (or 1 by 1 detection)?" "VELODYNE_FALSE" ]
    lappend format [list { "VELODYNE_TRUE" "VELODYNE_FALSE" } "Erase target points?" "VELODYNE_FALSE" ]
    lappend format [list { "VELODYNE_VERY_VERBOSE" "VELODYNE_VERBOSE" "VELODYNE_QUIET" } "Verbosity level of the detection process?" "VELODYNE_QUIET" ]

    return [ ::cs::rqstSend "${name}" "SetTargetDetectionParams" \
	"Specifies the target tracking process" \
	"velodyneTargetDetectionParams\n| velodyneBoolean detectionOn\n| velodyneBoolean trackingOn\n| velodyneBoolean eraseTargetPoints\n| velodyneVerbosity verbosity\n" \
	4 \
	$format \
	$args ]
}


proc ::velodyneSetTargetDetectionParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSetTargetDetectionParams
interp hide {} velodyneSetTargetDetectionParamsFormatOutput





# GetTargetDetectionParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneGetTargetDetectionParams] >= 0 } {
    interp expose {} velodyneGetTargetDetectionParams
}
if { [lsearch [interp hidden] velodyneGetTargetDetectionParamsFormatOutput] >= 0 } {
    interp expose {} velodyneGetTargetDetectionParamsFormatOutput
}

proc ::velodyneGetTargetDetectionParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetTargetDetectionParams" \
	"Prints the target detection params" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneGetTargetDetectionParamsFormatOutput { list } {
    set format { {} status { } { targetDetectionParams { } detectionOn { } trackingOn { } eraseTargetPoints { } verbosity } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneGetTargetDetectionParams
interp hide {} velodyneGetTargetDetectionParamsFormatOutput





# SetTargetDetectionFileOutput ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSetTargetDetectionFileOutput] >= 0 } {
    interp expose {} velodyneSetTargetDetectionFileOutput
}
if { [lsearch [interp hidden] velodyneSetTargetDetectionFileOutputFormatOutput] >= 0 } {
    interp expose {} velodyneSetTargetDetectionFileOutputFormatOutput
}

proc ::velodyneSetTargetDetectionFileOutput { name args } {
    set format {}
    lappend format [list { "VELODYNE_TRUE" "VELODYNE_FALSE" } "Enable file output?" "VELODYNE_FALSE" ]
    lappend format [list string "File name" "/tmp/target-detection" ]

    return [ ::cs::rqstSend "${name}" "SetTargetDetectionFileOutput" \
	"Sets the target detection file output parameters" \
	"velodyneTargetDetectionFileOutput\n| velodyneBoolean enabled\n| char fileName\[128\]\n" \
	2 \
	$format \
	$args ]
}


proc ::velodyneSetTargetDetectionFileOutputFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSetTargetDetectionFileOutput
interp hide {} velodyneSetTargetDetectionFileOutputFormatOutput





# GetTargetDetectionFileOutput ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneGetTargetDetectionFileOutput] >= 0 } {
    interp expose {} velodyneGetTargetDetectionFileOutput
}
if { [lsearch [interp hidden] velodyneGetTargetDetectionFileOutputFormatOutput] >= 0 } {
    interp expose {} velodyneGetTargetDetectionFileOutputFormatOutput
}

proc ::velodyneGetTargetDetectionFileOutput { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetTargetDetectionFileOutput" \
	"Gets the target detection file output parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneGetTargetDetectionFileOutputFormatOutput { list } {
    set format { {} status { } { targetDetectionFileOutput { } enabled { } fileName } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneGetTargetDetectionFileOutput
interp hide {} velodyneGetTargetDetectionFileOutputFormatOutput





# SetTargetParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSetTargetParams] >= 0 } {
    interp expose {} velodyneSetTargetParams
}
if { [lsearch [interp hidden] velodyneSetTargetParamsFormatOutput] >= 0 } {
    interp expose {} velodyneSetTargetParamsFormatOutput
}

proc ::velodyneSetTargetParams { name args } {
    set format {}
    lappend format [list float "Max target detection distance?" 20.000000 ]
    lappend format [list float "Minimum elevation of the target points" -1.000000 ]
    lappend format [list int "Minimum reflectance value?" 220 ]
    lappend format [list int "Maximum reflectance value?" 255 ]
    lappend format [list float "Cluster detection radius?" 0.500000 ]
    lappend format [list int "Nb of requested points to declare a target?" 2600 ]
    lappend format [list float "Min width of the target?" 0.300000 ]
    lappend format [list float "Max width of the target?" 0.800000 ]
    lappend format [list float "Min height of the target?" 0.250000 ]
    lappend format [list float "Max height of the target?" 1.000000 ]

    return [ ::cs::rqstSend "${name}" "SetTargetParams" \
	"Sets the target parameters" \
	"velodyneTargetParams\n| float maxDistance\n| float zMin\n| int minReflectance\n| int maxReflectance\n| float radius\n| int nbRequestedPoints\n| float minWidth\n| float maxWidth\n| float minHeight\n| float maxHeight\n" \
	10 \
	$format \
	$args ]
}


proc ::velodyneSetTargetParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSetTargetParams
interp hide {} velodyneSetTargetParamsFormatOutput





# GetTargetParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneGetTargetParams] >= 0 } {
    interp expose {} velodyneGetTargetParams
}
if { [lsearch [interp hidden] velodyneGetTargetParamsFormatOutput] >= 0 } {
    interp expose {} velodyneGetTargetParamsFormatOutput
}

proc ::velodyneGetTargetParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetTargetParams" \
	"Prints the target parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneGetTargetParamsFormatOutput { list } {
    set format { {} status { } { targetParams { } maxDistance { } zMin { } minReflectance { } maxReflectance { } radius { } nbRequestedPoints { } minWidth { } maxWidth { } minHeight { } maxHeight } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneGetTargetParams
interp hide {} velodyneGetTargetParamsFormatOutput





# StopTargetDetection ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneStopTargetDetection] >= 0 } {
    interp expose {} velodyneStopTargetDetection
}
if { [lsearch [interp hidden] velodyneStopTargetDetectionFormatOutput] >= 0 } {
    interp expose {} velodyneStopTargetDetectionFormatOutput
}

proc ::velodyneStopTargetDetection { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopTargetDetection" \
	"Stops the target detection process" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneStopTargetDetectionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneStopTargetDetection
interp hide {} velodyneStopTargetDetectionFormatOutput





# DumpTarget ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneDumpTarget] >= 0 } {
    interp expose {} velodyneDumpTarget
}
if { [lsearch [interp hidden] velodyneDumpTargetFormatOutput] >= 0 } {
    interp expose {} velodyneDumpTargetFormatOutput
}

proc ::velodyneDumpTarget { name args } {
    set format {}
    lappend format [list string "File name" "/tmp/velodyneShot" ]
    lappend format [list int "number of the extension" 0 ]

    return [ ::cs::rqstSend "${name}" "DumpTarget" \
	"Saves the target points in a ASCII file" \
	"velodyneSaveParams\n| char baseName\[128\]\n| int num\n" \
	2 \
	$format \
	$args ]
}


proc ::velodyneDumpTargetFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneDumpTarget
interp hide {} velodyneDumpTargetFormatOutput





# SetTargetTrackingParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSetTargetTrackingParams] >= 0 } {
    interp expose {} velodyneSetTargetTrackingParams
}
if { [lsearch [interp hidden] velodyneSetTargetTrackingParamsFormatOutput] >= 0 } {
    interp expose {} velodyneSetTargetTrackingParamsFormatOutput
}

proc ::velodyneSetTargetTrackingParams { name args } {
    set format {}
    lappend format [list float "Maximum target movement" 0.500000 ]

    return [ ::cs::rqstSend "${name}" "SetTargetTrackingParams" \
	"Sets the target tracking parameters" \
	"velodyneTargetTrackingParams\n| float maxTargetMovement\n" \
	1 \
	$format \
	$args ]
}


proc ::velodyneSetTargetTrackingParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSetTargetTrackingParams
interp hide {} velodyneSetTargetTrackingParamsFormatOutput





# GetTargetTrackingParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneGetTargetTrackingParams] >= 0 } {
    interp expose {} velodyneGetTargetTrackingParams
}
if { [lsearch [interp hidden] velodyneGetTargetTrackingParamsFormatOutput] >= 0 } {
    interp expose {} velodyneGetTargetTrackingParamsFormatOutput
}

proc ::velodyneGetTargetTrackingParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetTargetTrackingParams" \
	"Gets the target tracking parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneGetTargetTrackingParamsFormatOutput { list } {
    set format { {} status { } { targetTrackingParams { } maxTargetMovement } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneGetTargetTrackingParams
interp hide {} velodyneGetTargetTrackingParamsFormatOutput





# SetTargetTrackingFileOutputParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSetTargetTrackingFileOutputParams] >= 0 } {
    interp expose {} velodyneSetTargetTrackingFileOutputParams
}
if { [lsearch [interp hidden] velodyneSetTargetTrackingFileOutputParamsFormatOutput] >= 0 } {
    interp expose {} velodyneSetTargetTrackingFileOutputParamsFormatOutput
}

proc ::velodyneSetTargetTrackingFileOutputParams { name args } {
    set format {}
    lappend format [list { "VELODYNE_TRUE" "VELODYNE_FALSE" } "Enable file output?" "VELODYNE_TRUE" ]
    lappend format [list string "Output file name" "/tmp/trackedTargets" ]

    return [ ::cs::rqstSend "${name}" "SetTargetTrackingFileOutputParams" \
	"Sets the target tracking file output parameters" \
	"velodyneTargetTrackingFileOutputParams\n| velodyneBoolean enableFileOutput\n| char outputFileName\[128\]\n" \
	2 \
	$format \
	$args ]
}


proc ::velodyneSetTargetTrackingFileOutputParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSetTargetTrackingFileOutputParams
interp hide {} velodyneSetTargetTrackingFileOutputParamsFormatOutput





# GetTargetTrackingFileOutputParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneGetTargetTrackingFileOutputParams] >= 0 } {
    interp expose {} velodyneGetTargetTrackingFileOutputParams
}
if { [lsearch [interp hidden] velodyneGetTargetTrackingFileOutputParamsFormatOutput] >= 0 } {
    interp expose {} velodyneGetTargetTrackingFileOutputParamsFormatOutput
}

proc ::velodyneGetTargetTrackingFileOutputParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetTargetTrackingFileOutputParams" \
	"Gets the target tracking file output parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneGetTargetTrackingFileOutputParamsFormatOutput { list } {
    set format { {} status { } { targetTrackingFileOutputParams { } enableFileOutput { } outputFileName } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneGetTargetTrackingFileOutputParams
interp hide {} velodyneGetTargetTrackingFileOutputParamsFormatOutput





# SetSaveParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSetSaveParams] >= 0 } {
    interp expose {} velodyneSetSaveParams
}
if { [lsearch [interp hidden] velodyneSetSaveParamsFormatOutput] >= 0 } {
    interp expose {} velodyneSetSaveParamsFormatOutput
}

proc ::velodyneSetSaveParams { name args } {
    set format {}
    lappend format [list string "File name" "/tmp/velodyneShot" ]
    lappend format [list int "Number of the extension" 0 ]

    return [ ::cs::rqstSend "${name}" "SetSaveParams" \
	"Sets the file output parameters" \
	"velodyneSaveParams\n| char baseName\[128\]\n| int num\n" \
	2 \
	$format \
	$args ]
}


proc ::velodyneSetSaveParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSetSaveParams
interp hide {} velodyneSetSaveParamsFormatOutput





# GetSaveParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneGetSaveParams] >= 0 } {
    interp expose {} velodyneGetSaveParams
}
if { [lsearch [interp hidden] velodyneGetSaveParamsFormatOutput] >= 0 } {
    interp expose {} velodyneGetSaveParamsFormatOutput
}

proc ::velodyneGetSaveParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetSaveParams" \
	"Prints the file output parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneGetSaveParamsFormatOutput { list } {
    set format { {} status { } { saveParams { } baseName { } num } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneGetSaveParams
interp hide {} velodyneGetSaveParamsFormatOutput





# SetSaveIm3DParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSetSaveIm3DParams] >= 0 } {
    interp expose {} velodyneSetSaveIm3DParams
}
if { [lsearch [interp hidden] velodyneSetSaveIm3DParamsFormatOutput] >= 0 } {
    interp expose {} velodyneSetSaveIm3DParamsFormatOutput
}

proc ::velodyneSetSaveIm3DParams { name args } {
    set format {}
    lappend format [list string "File name" "/tmp/velodyneShotIm3D" ]
    lappend format [list int "Number of the extension" 0 ]

    return [ ::cs::rqstSend "${name}" "SetSaveIm3DParams" \
	"Sets the Images3D file output parameters" \
	"velodyneSaveParams\n| char baseName\[128\]\n| int num\n" \
	2 \
	$format \
	$args ]
}


proc ::velodyneSetSaveIm3DParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSetSaveIm3DParams
interp hide {} velodyneSetSaveIm3DParamsFormatOutput





# GetSaveIm3DParams ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneGetSaveIm3DParams] >= 0 } {
    interp expose {} velodyneGetSaveIm3DParams
}
if { [lsearch [interp hidden] velodyneGetSaveIm3DParamsFormatOutput] >= 0 } {
    interp expose {} velodyneGetSaveIm3DParamsFormatOutput
}

proc ::velodyneGetSaveIm3DParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetSaveIm3DParams" \
	"Prints the Images3D file output parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneGetSaveIm3DParamsFormatOutput { list } {
    set format { {} status { } { saveIm3DParams { } baseName { } num } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneGetSaveIm3DParams
interp hide {} velodyneGetSaveIm3DParamsFormatOutput





# Save ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSave] >= 0 } {
    interp expose {} velodyneSave
}
if { [lsearch [interp hidden] velodyneSaveFormatOutput] >= 0 } {
    interp expose {} velodyneSaveFormatOutput
}

proc ::velodyneSave { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Save" \
	"Saves the acquired shot" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneSaveFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSave
interp hide {} velodyneSaveFormatOutput





# SaveIm3D ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneSaveIm3D] >= 0 } {
    interp expose {} velodyneSaveIm3D
}
if { [lsearch [interp hidden] velodyneSaveIm3DFormatOutput] >= 0 } {
    interp expose {} velodyneSaveIm3DFormatOutput
}

proc ::velodyneSaveIm3D { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SaveIm3D" \
	"Saves the acquired shot in the Images3D format" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::velodyneSaveIm3DFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneSaveIm3D
interp hide {} velodyneSaveIm3DFormatOutput





# ThreeDImagevelodyne3DImage ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneThreeDImagevelodyne3DImagePosterRead] >= 0 } {
    interp expose {} velodyneThreeDImagevelodyne3DImagePosterRead
}
if { [lsearch [interp hidden] velodyneThreeDImagevelodyne3DImagePosterFormatOutput] >= 0 } {
    interp expose {} velodyneThreeDImagevelodyne3DImagePosterFormatOutput
}

proc ::velodyneThreeDImagevelodyne3DImagePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "ThreeDImagevelodyne3DImage" \
	"velodyne3DImage\n| POM_SENSOR_POS\n| | int date\n| | int pad\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| velodyne3DPoint\n| | float coordinates\[3\]\n| | short int intensity\n| | velodyne3DPointStatus status\n| int height\n| int width\n| int maxScanWidth\n" \
	$args ]
}


proc ::velodyneThreeDImagevelodyne3DImagePosterFormatOutput { list } {
    set format { {} status { } { velodyne3DImage { } { position { } date { } pad { } { sensorToMain { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToBase { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToOrigin { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } { 304000 } { points { 3 } coordinates { } intensity { } status } { } height { } width { } maxScanWidth } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneThreeDImagevelodyne3DImagePosterRead
interp hide {} velodyneThreeDImagevelodyne3DImagePosterFormatOutput





# TargetAbsolutePositionGENPOS_TRAJ_POINTS ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSPosterRead] >= 0 } {
    interp expose {} velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSPosterRead
}
if { [lsearch [interp hidden] velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSPosterFormatOutput] >= 0 } {
    interp expose {} velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSPosterFormatOutput
}

proc ::velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "TargetAbsolutePositionGENPOS_TRAJ_POINTS" \
	"GENPOS_TRAJ_POINTS\n| int numRef\n| int nbPts\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n" \
	$args ]
}


proc ::velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSPosterFormatOutput { list } {
    set format { {} status { } { GENPOS_TRAJ_POINTS { } numRef { } nbPts { 1000 } { points { } x { } y { } theta } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSPosterRead
interp hide {} velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSPosterFormatOutput





# TargetRelativePositionGENPOS_TRAJ_POINTS ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneTargetRelativePositionGENPOS_TRAJ_POINTSPosterRead] >= 0 } {
    interp expose {} velodyneTargetRelativePositionGENPOS_TRAJ_POINTSPosterRead
}
if { [lsearch [interp hidden] velodyneTargetRelativePositionGENPOS_TRAJ_POINTSPosterFormatOutput] >= 0 } {
    interp expose {} velodyneTargetRelativePositionGENPOS_TRAJ_POINTSPosterFormatOutput
}

proc ::velodyneTargetRelativePositionGENPOS_TRAJ_POINTSPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "TargetRelativePositionGENPOS_TRAJ_POINTS" \
	"GENPOS_TRAJ_POINTS\n| int numRef\n| int nbPts\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n" \
	$args ]
}


proc ::velodyneTargetRelativePositionGENPOS_TRAJ_POINTSPosterFormatOutput { list } {
    set format { {} status { } { GENPOS_TRAJ_POINTS { } numRef { } nbPts { 1000 } { points { } x { } y { } theta } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneTargetRelativePositionGENPOS_TRAJ_POINTSPosterRead
interp hide {} velodyneTargetRelativePositionGENPOS_TRAJ_POINTSPosterFormatOutput





# TargetTrackingGENPOS_TRAJ_POINTS ----------------------------------------------------------

if { [lsearch [interp hidden] velodyneTargetTrackingGENPOS_TRAJ_POINTSPosterRead] >= 0 } {
    interp expose {} velodyneTargetTrackingGENPOS_TRAJ_POINTSPosterRead
}
if { [lsearch [interp hidden] velodyneTargetTrackingGENPOS_TRAJ_POINTSPosterFormatOutput] >= 0 } {
    interp expose {} velodyneTargetTrackingGENPOS_TRAJ_POINTSPosterFormatOutput
}

proc ::velodyneTargetTrackingGENPOS_TRAJ_POINTSPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "TargetTrackingGENPOS_TRAJ_POINTS" \
	"GENPOS_TRAJ_POINTS\n| int numRef\n| int nbPts\n| GENPOS_CART_CONFIG\n| | double x\n| | double y\n| | double theta\n" \
	$args ]
}


proc ::velodyneTargetTrackingGENPOS_TRAJ_POINTSPosterFormatOutput { list } {
    set format { {} status { } { GENPOS_TRAJ_POINTS { } numRef { } nbPts { 1000 } { points { } x { } y { } theta } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} velodyneTargetTrackingGENPOS_TRAJ_POINTSPosterRead
interp hide {} velodyneTargetTrackingGENPOS_TRAJ_POINTSPosterFormatOutput


